unit DemoMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFrmDemo = class(TForm)
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
    procedure LibGetProcErrorEvent (const aLibName, aProcName: string; const aErrorCode: LongWord);
    procedure LibErrorEvent (const aLibName: string; const aErrorCode: LongWord);
  end;

var
  FrmDemo: TFrmDemo;

implementation

{$R *.dfm}

Uses LibLoader;


var
  { on vas recupr GetTickCount dans Kernel32.dll }
  LibKernel32     : TLibraryLoader;
  DynGetTickCount : function : DWORD; stdcall;

  { ici on vas provoquer volontairement une erreur }
  LibUnknown : TLibraryLoader;
  DynUnknown : function : DWORD; cdecl;



procedure TFrmDemo.FormCreate(Sender: TObject);
begin
  { LibKernel32 : ne doit pas provoquer d'erreur }
  LibKernel32 := TLibraryLoader.Create(Kernel32);
  LibKernel32.OnLibError     := LibErrorEvent;
  LibKernel32.OnGetProcError := LibGetProcErrorEvent;

  LibKernel32.Load;

  if LibKernel32.GetProc('GetTickCount', @DynGetTickCount) then
    caption := format('%d =? %d',[DynGetTickCount, GetTickCount]);

  { LibUnknown : renvera deux erreur librairie inconnue et procedure inconnue }
  LibUnknown := TLibraryLoader.Create('unknown.dll');
  LibUnknown.OnLibError := LibErrorEvent;
  LibUnknown.OnGetProcError := LibGetProcErrorEvent;

  LibUnknown.Load;

  if LibUnknown.GetProc('Unknown', @DynUnknown) then
    ShowMessage('Incroyable! il existe une fonction Unknown dans Unknown.dll!');

end;

procedure TFrmDemo.FormDestroy(Sender: TObject);
begin
  { on libere les loaders, ils dechargent automatiquement les librairies }
  LibUnknown.Free;
  LibKernel32.Free;
end;

procedure TFrmDemo.LibErrorEvent(const aLibName: string; const aErrorCode: LongWord);
begin
  { affichage des messages d'erreur de LibraryLoader (Load/Unload) }
  ListBox1.Items.Add('LibraryLoader error ['+aLibName+'] : '+SysErrorMessage(aErrorCode));
end;

procedure TFrmDemo.LibGetProcErrorEvent(const aLibName, aProcName: string; const aErrorCode: LongWord);
begin
  { affichage des messages d'erreur de LibraryLoader (GetProc, GetProcs) }
  ListBox1.Items.Add('LibraryLoader Proc error ['+aLibName+'] : '+aProcName+' '+SysErrorMessage(aErrorCode));
end;

end.
